// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: seacow.proto
// </auto-generated>
#pragma warning disable 0414, 1591
#region Designer generated code

using grpc = global::Grpc.Core;

namespace Seacow {
  /// <summary>
  /// ContextManager Service
  /// </summary>
  public static partial class ContextManager
  {
    static readonly string __ServiceName = "seacow.ContextManager";

    static readonly grpc::Marshaller<global::Seacow.SetActiveRequest> __Marshaller_seacow_SetActiveRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.SetActiveRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.SetActiveResponse> __Marshaller_seacow_SetActiveResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.SetActiveResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.JoinCommonContextRequest> __Marshaller_seacow_JoinCommonContextRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.JoinCommonContextRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.JoinCommonContextResponse> __Marshaller_seacow_JoinCommonContextResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.JoinCommonContextResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.LeaveCommonContextRequest> __Marshaller_seacow_LeaveCommonContextRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.LeaveCommonContextRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.LeaveCommonContextResponse> __Marshaller_seacow_LeaveCommonContextResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.LeaveCommonContextResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.StartContextChangesRequest> __Marshaller_seacow_StartContextChangesRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.StartContextChangesRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.StartContextChangesResponse> __Marshaller_seacow_StartContextChangesResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.StartContextChangesResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.EndContextChangesRequest> __Marshaller_seacow_EndContextChangesRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.EndContextChangesRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.EndContextChangesResponse> __Marshaller_seacow_EndContextChangesResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.EndContextChangesResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.UndoContextChangesRequest> __Marshaller_seacow_UndoContextChangesRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.UndoContextChangesRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.UndoContextChangesResponse> __Marshaller_seacow_UndoContextChangesResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.UndoContextChangesResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.PublishChangesDecisionRequest> __Marshaller_seacow_PublishChangesDecisionRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.PublishChangesDecisionRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.PublishChangesDecisionResponse> __Marshaller_seacow_PublishChangesDecisionResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.PublishChangesDecisionResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.SuspendParticipationRequest> __Marshaller_seacow_SuspendParticipationRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.SuspendParticipationRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.SuspendParticipationResponse> __Marshaller_seacow_SuspendParticipationResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.SuspendParticipationResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ResumeParticipationRequest> __Marshaller_seacow_ResumeParticipationRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ResumeParticipationRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ResumeParticipationResponse> __Marshaller_seacow_ResumeParticipationResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ResumeParticipationResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.MostRecentContextCouponRequest> __Marshaller_seacow_MostRecentContextCouponRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.MostRecentContextCouponRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.MostRecentContextCouponResponse> __Marshaller_seacow_MostRecentContextCouponResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.MostRecentContextCouponResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.InstanceInformationRequest> __Marshaller_seacow_InstanceInformationRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.InstanceInformationRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.InstanceInformationResponse> __Marshaller_seacow_InstanceInformationResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.InstanceInformationResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ImplementationInformationRequest> __Marshaller_seacow_ImplementationInformationRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ImplementationInformationRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ImplementationInformationResponse> __Marshaller_seacow_ImplementationInformationResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ImplementationInformationResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ContextParticipantStreamRequest> __Marshaller_seacow_ContextParticipantStreamRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ContextParticipantStreamRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ContextParticipantStreamResponse> __Marshaller_seacow_ContextParticipantStreamResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ContextParticipantStreamResponse.Parser.ParseFrom);

    static readonly grpc::Method<global::Seacow.SetActiveRequest, global::Seacow.SetActiveResponse> __Method_SetActive = new grpc::Method<global::Seacow.SetActiveRequest, global::Seacow.SetActiveResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "SetActive",
        __Marshaller_seacow_SetActiveRequest,
        __Marshaller_seacow_SetActiveResponse);

    static readonly grpc::Method<global::Seacow.JoinCommonContextRequest, global::Seacow.JoinCommonContextResponse> __Method_JoinCommonContext = new grpc::Method<global::Seacow.JoinCommonContextRequest, global::Seacow.JoinCommonContextResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "JoinCommonContext",
        __Marshaller_seacow_JoinCommonContextRequest,
        __Marshaller_seacow_JoinCommonContextResponse);

    static readonly grpc::Method<global::Seacow.LeaveCommonContextRequest, global::Seacow.LeaveCommonContextResponse> __Method_LeaveCommonContext = new grpc::Method<global::Seacow.LeaveCommonContextRequest, global::Seacow.LeaveCommonContextResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "LeaveCommonContext",
        __Marshaller_seacow_LeaveCommonContextRequest,
        __Marshaller_seacow_LeaveCommonContextResponse);

    static readonly grpc::Method<global::Seacow.StartContextChangesRequest, global::Seacow.StartContextChangesResponse> __Method_StartContextChanges = new grpc::Method<global::Seacow.StartContextChangesRequest, global::Seacow.StartContextChangesResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "StartContextChanges",
        __Marshaller_seacow_StartContextChangesRequest,
        __Marshaller_seacow_StartContextChangesResponse);

    static readonly grpc::Method<global::Seacow.EndContextChangesRequest, global::Seacow.EndContextChangesResponse> __Method_EndContextChanges = new grpc::Method<global::Seacow.EndContextChangesRequest, global::Seacow.EndContextChangesResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "EndContextChanges",
        __Marshaller_seacow_EndContextChangesRequest,
        __Marshaller_seacow_EndContextChangesResponse);

    static readonly grpc::Method<global::Seacow.UndoContextChangesRequest, global::Seacow.UndoContextChangesResponse> __Method_UndoContextChanges = new grpc::Method<global::Seacow.UndoContextChangesRequest, global::Seacow.UndoContextChangesResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "UndoContextChanges",
        __Marshaller_seacow_UndoContextChangesRequest,
        __Marshaller_seacow_UndoContextChangesResponse);

    static readonly grpc::Method<global::Seacow.PublishChangesDecisionRequest, global::Seacow.PublishChangesDecisionResponse> __Method_PublishChangesDecision = new grpc::Method<global::Seacow.PublishChangesDecisionRequest, global::Seacow.PublishChangesDecisionResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "PublishChangesDecision",
        __Marshaller_seacow_PublishChangesDecisionRequest,
        __Marshaller_seacow_PublishChangesDecisionResponse);

    static readonly grpc::Method<global::Seacow.SuspendParticipationRequest, global::Seacow.SuspendParticipationResponse> __Method_SuspendParticipation = new grpc::Method<global::Seacow.SuspendParticipationRequest, global::Seacow.SuspendParticipationResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "SuspendParticipation",
        __Marshaller_seacow_SuspendParticipationRequest,
        __Marshaller_seacow_SuspendParticipationResponse);

    static readonly grpc::Method<global::Seacow.ResumeParticipationRequest, global::Seacow.ResumeParticipationResponse> __Method_ResumeParticipation = new grpc::Method<global::Seacow.ResumeParticipationRequest, global::Seacow.ResumeParticipationResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "ResumeParticipation",
        __Marshaller_seacow_ResumeParticipationRequest,
        __Marshaller_seacow_ResumeParticipationResponse);

    static readonly grpc::Method<global::Seacow.MostRecentContextCouponRequest, global::Seacow.MostRecentContextCouponResponse> __Method_MostRecentContextCoupon = new grpc::Method<global::Seacow.MostRecentContextCouponRequest, global::Seacow.MostRecentContextCouponResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "MostRecentContextCoupon",
        __Marshaller_seacow_MostRecentContextCouponRequest,
        __Marshaller_seacow_MostRecentContextCouponResponse);

    static readonly grpc::Method<global::Seacow.InstanceInformationRequest, global::Seacow.InstanceInformationResponse> __Method_InstanceInformation = new grpc::Method<global::Seacow.InstanceInformationRequest, global::Seacow.InstanceInformationResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "InstanceInformation",
        __Marshaller_seacow_InstanceInformationRequest,
        __Marshaller_seacow_InstanceInformationResponse);

    static readonly grpc::Method<global::Seacow.ImplementationInformationRequest, global::Seacow.ImplementationInformationResponse> __Method_ImplementationInformation = new grpc::Method<global::Seacow.ImplementationInformationRequest, global::Seacow.ImplementationInformationResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "ImplementationInformation",
        __Marshaller_seacow_ImplementationInformationRequest,
        __Marshaller_seacow_ImplementationInformationResponse);

    static readonly grpc::Method<global::Seacow.ContextParticipantStreamRequest, global::Seacow.ContextParticipantStreamResponse> __Method_ContextParticipantStream = new grpc::Method<global::Seacow.ContextParticipantStreamRequest, global::Seacow.ContextParticipantStreamResponse>(
        grpc::MethodType.DuplexStreaming,
        __ServiceName,
        "ContextParticipantStream",
        __Marshaller_seacow_ContextParticipantStreamRequest,
        __Marshaller_seacow_ContextParticipantStreamResponse);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Seacow.SeacowReflection.Descriptor.Services[0]; }
    }

    /// <summary>Base class for server-side implementations of ContextManager</summary>
    public abstract partial class ContextManagerBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Seacow.SetActiveResponse> SetActive(global::Seacow.SetActiveRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.JoinCommonContextResponse> JoinCommonContext(global::Seacow.JoinCommonContextRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.LeaveCommonContextResponse> LeaveCommonContext(global::Seacow.LeaveCommonContextRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.StartContextChangesResponse> StartContextChanges(global::Seacow.StartContextChangesRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.EndContextChangesResponse> EndContextChanges(global::Seacow.EndContextChangesRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.UndoContextChangesResponse> UndoContextChanges(global::Seacow.UndoContextChangesRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.PublishChangesDecisionResponse> PublishChangesDecision(global::Seacow.PublishChangesDecisionRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.SuspendParticipationResponse> SuspendParticipation(global::Seacow.SuspendParticipationRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.ResumeParticipationResponse> ResumeParticipation(global::Seacow.ResumeParticipationRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.MostRecentContextCouponResponse> MostRecentContextCoupon(global::Seacow.MostRecentContextCouponRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.InstanceInformationResponse> InstanceInformation(global::Seacow.InstanceInformationRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.ImplementationInformationResponse> ImplementationInformation(global::Seacow.ImplementationInformationRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task ContextParticipantStream(grpc::IAsyncStreamReader<global::Seacow.ContextParticipantStreamRequest> requestStream, grpc::IServerStreamWriter<global::Seacow.ContextParticipantStreamResponse> responseStream, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for ContextManager</summary>
    public partial class ContextManagerClient : grpc::ClientBase<ContextManagerClient>
    {
      /// <summary>Creates a new client for ContextManager</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public ContextManagerClient(grpc::Channel channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for ContextManager that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public ContextManagerClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected ContextManagerClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected ContextManagerClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Seacow.SetActiveResponse SetActive(global::Seacow.SetActiveRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SetActive(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.SetActiveResponse SetActive(global::Seacow.SetActiveRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_SetActive, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.SetActiveResponse> SetActiveAsync(global::Seacow.SetActiveRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SetActiveAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.SetActiveResponse> SetActiveAsync(global::Seacow.SetActiveRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_SetActive, null, options, request);
      }
      public virtual global::Seacow.JoinCommonContextResponse JoinCommonContext(global::Seacow.JoinCommonContextRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return JoinCommonContext(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.JoinCommonContextResponse JoinCommonContext(global::Seacow.JoinCommonContextRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_JoinCommonContext, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.JoinCommonContextResponse> JoinCommonContextAsync(global::Seacow.JoinCommonContextRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return JoinCommonContextAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.JoinCommonContextResponse> JoinCommonContextAsync(global::Seacow.JoinCommonContextRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_JoinCommonContext, null, options, request);
      }
      public virtual global::Seacow.LeaveCommonContextResponse LeaveCommonContext(global::Seacow.LeaveCommonContextRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return LeaveCommonContext(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.LeaveCommonContextResponse LeaveCommonContext(global::Seacow.LeaveCommonContextRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_LeaveCommonContext, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.LeaveCommonContextResponse> LeaveCommonContextAsync(global::Seacow.LeaveCommonContextRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return LeaveCommonContextAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.LeaveCommonContextResponse> LeaveCommonContextAsync(global::Seacow.LeaveCommonContextRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_LeaveCommonContext, null, options, request);
      }
      public virtual global::Seacow.StartContextChangesResponse StartContextChanges(global::Seacow.StartContextChangesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return StartContextChanges(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.StartContextChangesResponse StartContextChanges(global::Seacow.StartContextChangesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_StartContextChanges, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.StartContextChangesResponse> StartContextChangesAsync(global::Seacow.StartContextChangesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return StartContextChangesAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.StartContextChangesResponse> StartContextChangesAsync(global::Seacow.StartContextChangesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_StartContextChanges, null, options, request);
      }
      public virtual global::Seacow.EndContextChangesResponse EndContextChanges(global::Seacow.EndContextChangesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return EndContextChanges(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.EndContextChangesResponse EndContextChanges(global::Seacow.EndContextChangesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_EndContextChanges, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.EndContextChangesResponse> EndContextChangesAsync(global::Seacow.EndContextChangesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return EndContextChangesAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.EndContextChangesResponse> EndContextChangesAsync(global::Seacow.EndContextChangesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_EndContextChanges, null, options, request);
      }
      public virtual global::Seacow.UndoContextChangesResponse UndoContextChanges(global::Seacow.UndoContextChangesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return UndoContextChanges(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.UndoContextChangesResponse UndoContextChanges(global::Seacow.UndoContextChangesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_UndoContextChanges, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.UndoContextChangesResponse> UndoContextChangesAsync(global::Seacow.UndoContextChangesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return UndoContextChangesAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.UndoContextChangesResponse> UndoContextChangesAsync(global::Seacow.UndoContextChangesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_UndoContextChanges, null, options, request);
      }
      public virtual global::Seacow.PublishChangesDecisionResponse PublishChangesDecision(global::Seacow.PublishChangesDecisionRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return PublishChangesDecision(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.PublishChangesDecisionResponse PublishChangesDecision(global::Seacow.PublishChangesDecisionRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_PublishChangesDecision, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.PublishChangesDecisionResponse> PublishChangesDecisionAsync(global::Seacow.PublishChangesDecisionRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return PublishChangesDecisionAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.PublishChangesDecisionResponse> PublishChangesDecisionAsync(global::Seacow.PublishChangesDecisionRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_PublishChangesDecision, null, options, request);
      }
      public virtual global::Seacow.SuspendParticipationResponse SuspendParticipation(global::Seacow.SuspendParticipationRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SuspendParticipation(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.SuspendParticipationResponse SuspendParticipation(global::Seacow.SuspendParticipationRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_SuspendParticipation, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.SuspendParticipationResponse> SuspendParticipationAsync(global::Seacow.SuspendParticipationRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SuspendParticipationAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.SuspendParticipationResponse> SuspendParticipationAsync(global::Seacow.SuspendParticipationRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_SuspendParticipation, null, options, request);
      }
      public virtual global::Seacow.ResumeParticipationResponse ResumeParticipation(global::Seacow.ResumeParticipationRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ResumeParticipation(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.ResumeParticipationResponse ResumeParticipation(global::Seacow.ResumeParticipationRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_ResumeParticipation, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ResumeParticipationResponse> ResumeParticipationAsync(global::Seacow.ResumeParticipationRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ResumeParticipationAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ResumeParticipationResponse> ResumeParticipationAsync(global::Seacow.ResumeParticipationRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_ResumeParticipation, null, options, request);
      }
      public virtual global::Seacow.MostRecentContextCouponResponse MostRecentContextCoupon(global::Seacow.MostRecentContextCouponRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return MostRecentContextCoupon(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.MostRecentContextCouponResponse MostRecentContextCoupon(global::Seacow.MostRecentContextCouponRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_MostRecentContextCoupon, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.MostRecentContextCouponResponse> MostRecentContextCouponAsync(global::Seacow.MostRecentContextCouponRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return MostRecentContextCouponAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.MostRecentContextCouponResponse> MostRecentContextCouponAsync(global::Seacow.MostRecentContextCouponRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_MostRecentContextCoupon, null, options, request);
      }
      public virtual global::Seacow.InstanceInformationResponse InstanceInformation(global::Seacow.InstanceInformationRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return InstanceInformation(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.InstanceInformationResponse InstanceInformation(global::Seacow.InstanceInformationRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_InstanceInformation, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.InstanceInformationResponse> InstanceInformationAsync(global::Seacow.InstanceInformationRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return InstanceInformationAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.InstanceInformationResponse> InstanceInformationAsync(global::Seacow.InstanceInformationRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_InstanceInformation, null, options, request);
      }
      public virtual global::Seacow.ImplementationInformationResponse ImplementationInformation(global::Seacow.ImplementationInformationRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ImplementationInformation(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.ImplementationInformationResponse ImplementationInformation(global::Seacow.ImplementationInformationRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_ImplementationInformation, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ImplementationInformationResponse> ImplementationInformationAsync(global::Seacow.ImplementationInformationRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ImplementationInformationAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ImplementationInformationResponse> ImplementationInformationAsync(global::Seacow.ImplementationInformationRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_ImplementationInformation, null, options, request);
      }
      public virtual grpc::AsyncDuplexStreamingCall<global::Seacow.ContextParticipantStreamRequest, global::Seacow.ContextParticipantStreamResponse> ContextParticipantStream(grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ContextParticipantStream(new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncDuplexStreamingCall<global::Seacow.ContextParticipantStreamRequest, global::Seacow.ContextParticipantStreamResponse> ContextParticipantStream(grpc::CallOptions options)
      {
        return CallInvoker.AsyncDuplexStreamingCall(__Method_ContextParticipantStream, null, options);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override ContextManagerClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new ContextManagerClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(ContextManagerBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_SetActive, serviceImpl.SetActive)
          .AddMethod(__Method_JoinCommonContext, serviceImpl.JoinCommonContext)
          .AddMethod(__Method_LeaveCommonContext, serviceImpl.LeaveCommonContext)
          .AddMethod(__Method_StartContextChanges, serviceImpl.StartContextChanges)
          .AddMethod(__Method_EndContextChanges, serviceImpl.EndContextChanges)
          .AddMethod(__Method_UndoContextChanges, serviceImpl.UndoContextChanges)
          .AddMethod(__Method_PublishChangesDecision, serviceImpl.PublishChangesDecision)
          .AddMethod(__Method_SuspendParticipation, serviceImpl.SuspendParticipation)
          .AddMethod(__Method_ResumeParticipation, serviceImpl.ResumeParticipation)
          .AddMethod(__Method_MostRecentContextCoupon, serviceImpl.MostRecentContextCoupon)
          .AddMethod(__Method_InstanceInformation, serviceImpl.InstanceInformation)
          .AddMethod(__Method_ImplementationInformation, serviceImpl.ImplementationInformation)
          .AddMethod(__Method_ContextParticipantStream, serviceImpl.ContextParticipantStream).Build();
    }

  }
  /// <summary>
  /// ContextData Service
  /// </summary>
  public static partial class ContextData
  {
    static readonly string __ServiceName = "seacow.ContextData";

    static readonly grpc::Marshaller<global::Seacow.GetItemNamesRequest> __Marshaller_seacow_GetItemNamesRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.GetItemNamesRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.GetItemNamesResponse> __Marshaller_seacow_GetItemNamesResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.GetItemNamesResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.DeleteItemsRequest> __Marshaller_seacow_DeleteItemsRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.DeleteItemsRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.DeleteItemsResponse> __Marshaller_seacow_DeleteItemsResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.DeleteItemsResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.SetItemValuesRequest> __Marshaller_seacow_SetItemValuesRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.SetItemValuesRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.SetItemValuesResponse> __Marshaller_seacow_SetItemValuesResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.SetItemValuesResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.GetItemValuesRequest> __Marshaller_seacow_GetItemValuesRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.GetItemValuesRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.GetItemValuesResponse> __Marshaller_seacow_GetItemValuesResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.GetItemValuesResponse.Parser.ParseFrom);

    static readonly grpc::Method<global::Seacow.GetItemNamesRequest, global::Seacow.GetItemNamesResponse> __Method_GetItemNames = new grpc::Method<global::Seacow.GetItemNamesRequest, global::Seacow.GetItemNamesResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetItemNames",
        __Marshaller_seacow_GetItemNamesRequest,
        __Marshaller_seacow_GetItemNamesResponse);

    static readonly grpc::Method<global::Seacow.DeleteItemsRequest, global::Seacow.DeleteItemsResponse> __Method_DeleteItems = new grpc::Method<global::Seacow.DeleteItemsRequest, global::Seacow.DeleteItemsResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "DeleteItems",
        __Marshaller_seacow_DeleteItemsRequest,
        __Marshaller_seacow_DeleteItemsResponse);

    static readonly grpc::Method<global::Seacow.SetItemValuesRequest, global::Seacow.SetItemValuesResponse> __Method_SetItemValues = new grpc::Method<global::Seacow.SetItemValuesRequest, global::Seacow.SetItemValuesResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "SetItemValues",
        __Marshaller_seacow_SetItemValuesRequest,
        __Marshaller_seacow_SetItemValuesResponse);

    static readonly grpc::Method<global::Seacow.GetItemValuesRequest, global::Seacow.GetItemValuesResponse> __Method_GetItemValues = new grpc::Method<global::Seacow.GetItemValuesRequest, global::Seacow.GetItemValuesResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetItemValues",
        __Marshaller_seacow_GetItemValuesRequest,
        __Marshaller_seacow_GetItemValuesResponse);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Seacow.SeacowReflection.Descriptor.Services[1]; }
    }

    /// <summary>Base class for server-side implementations of ContextData</summary>
    public abstract partial class ContextDataBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Seacow.GetItemNamesResponse> GetItemNames(global::Seacow.GetItemNamesRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.DeleteItemsResponse> DeleteItems(global::Seacow.DeleteItemsRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.SetItemValuesResponse> SetItemValues(global::Seacow.SetItemValuesRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.GetItemValuesResponse> GetItemValues(global::Seacow.GetItemValuesRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for ContextData</summary>
    public partial class ContextDataClient : grpc::ClientBase<ContextDataClient>
    {
      /// <summary>Creates a new client for ContextData</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public ContextDataClient(grpc::Channel channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for ContextData that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public ContextDataClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected ContextDataClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected ContextDataClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Seacow.GetItemNamesResponse GetItemNames(global::Seacow.GetItemNamesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetItemNames(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.GetItemNamesResponse GetItemNames(global::Seacow.GetItemNamesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetItemNames, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.GetItemNamesResponse> GetItemNamesAsync(global::Seacow.GetItemNamesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetItemNamesAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.GetItemNamesResponse> GetItemNamesAsync(global::Seacow.GetItemNamesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetItemNames, null, options, request);
      }
      public virtual global::Seacow.DeleteItemsResponse DeleteItems(global::Seacow.DeleteItemsRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return DeleteItems(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.DeleteItemsResponse DeleteItems(global::Seacow.DeleteItemsRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_DeleteItems, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.DeleteItemsResponse> DeleteItemsAsync(global::Seacow.DeleteItemsRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return DeleteItemsAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.DeleteItemsResponse> DeleteItemsAsync(global::Seacow.DeleteItemsRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_DeleteItems, null, options, request);
      }
      public virtual global::Seacow.SetItemValuesResponse SetItemValues(global::Seacow.SetItemValuesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SetItemValues(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.SetItemValuesResponse SetItemValues(global::Seacow.SetItemValuesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_SetItemValues, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.SetItemValuesResponse> SetItemValuesAsync(global::Seacow.SetItemValuesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SetItemValuesAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.SetItemValuesResponse> SetItemValuesAsync(global::Seacow.SetItemValuesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_SetItemValues, null, options, request);
      }
      public virtual global::Seacow.GetItemValuesResponse GetItemValues(global::Seacow.GetItemValuesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetItemValues(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.GetItemValuesResponse GetItemValues(global::Seacow.GetItemValuesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetItemValues, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.GetItemValuesResponse> GetItemValuesAsync(global::Seacow.GetItemValuesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetItemValuesAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.GetItemValuesResponse> GetItemValuesAsync(global::Seacow.GetItemValuesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetItemValues, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override ContextDataClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new ContextDataClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(ContextDataBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_GetItemNames, serviceImpl.GetItemNames)
          .AddMethod(__Method_DeleteItems, serviceImpl.DeleteItems)
          .AddMethod(__Method_SetItemValues, serviceImpl.SetItemValues)
          .AddMethod(__Method_GetItemValues, serviceImpl.GetItemValues).Build();
    }

  }
  /// <summary>
  /// ContextSession Service
  /// </summary>
  public static partial class ContextSession
  {
    static readonly string __ServiceName = "seacow.ContextSession";

    static readonly grpc::Marshaller<global::Seacow.CreateRequest> __Marshaller_seacow_CreateRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.CreateRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.CreateResponse> __Marshaller_seacow_CreateResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.CreateResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ActivateRequest> __Marshaller_seacow_ActivateRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ActivateRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ActivateResponse> __Marshaller_seacow_ActivateResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ActivateResponse.Parser.ParseFrom);

    static readonly grpc::Method<global::Seacow.CreateRequest, global::Seacow.CreateResponse> __Method_Create = new grpc::Method<global::Seacow.CreateRequest, global::Seacow.CreateResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "Create",
        __Marshaller_seacow_CreateRequest,
        __Marshaller_seacow_CreateResponse);

    static readonly grpc::Method<global::Seacow.ActivateRequest, global::Seacow.ActivateResponse> __Method_Activate = new grpc::Method<global::Seacow.ActivateRequest, global::Seacow.ActivateResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "Activate",
        __Marshaller_seacow_ActivateRequest,
        __Marshaller_seacow_ActivateResponse);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Seacow.SeacowReflection.Descriptor.Services[2]; }
    }

    /// <summary>Base class for server-side implementations of ContextSession</summary>
    public abstract partial class ContextSessionBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Seacow.CreateResponse> Create(global::Seacow.CreateRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.ActivateResponse> Activate(global::Seacow.ActivateRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for ContextSession</summary>
    public partial class ContextSessionClient : grpc::ClientBase<ContextSessionClient>
    {
      /// <summary>Creates a new client for ContextSession</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public ContextSessionClient(grpc::Channel channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for ContextSession that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public ContextSessionClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected ContextSessionClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected ContextSessionClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Seacow.CreateResponse Create(global::Seacow.CreateRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return Create(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.CreateResponse Create(global::Seacow.CreateRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_Create, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.CreateResponse> CreateAsync(global::Seacow.CreateRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return CreateAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.CreateResponse> CreateAsync(global::Seacow.CreateRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_Create, null, options, request);
      }
      public virtual global::Seacow.ActivateResponse Activate(global::Seacow.ActivateRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return Activate(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.ActivateResponse Activate(global::Seacow.ActivateRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_Activate, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ActivateResponse> ActivateAsync(global::Seacow.ActivateRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ActivateAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ActivateResponse> ActivateAsync(global::Seacow.ActivateRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_Activate, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override ContextSessionClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new ContextSessionClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(ContextSessionBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_Create, serviceImpl.Create)
          .AddMethod(__Method_Activate, serviceImpl.Activate).Build();
    }

  }
  /// <summary>
  /// ContextFilter Service
  /// </summary>
  public static partial class ContextFilter
  {
    static readonly string __ServiceName = "seacow.ContextFilter";

    static readonly grpc::Marshaller<global::Seacow.SetSubjectsOfInterestRequest> __Marshaller_seacow_SetSubjectsOfInterestRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.SetSubjectsOfInterestRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.SetSubjectsOfInterestResponse> __Marshaller_seacow_SetSubjectsOfInterestResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.SetSubjectsOfInterestResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.GetSubjectsOfInterestRequest> __Marshaller_seacow_GetSubjectsOfInterestRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.GetSubjectsOfInterestRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.GetSubjectsOfInterestResponse> __Marshaller_seacow_GetSubjectsOfInterestResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.GetSubjectsOfInterestResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ClearFilterRequest> __Marshaller_seacow_ClearFilterRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ClearFilterRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ClearFilterResponse> __Marshaller_seacow_ClearFilterResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ClearFilterResponse.Parser.ParseFrom);

    static readonly grpc::Method<global::Seacow.SetSubjectsOfInterestRequest, global::Seacow.SetSubjectsOfInterestResponse> __Method_SetSubjectsOfInterest = new grpc::Method<global::Seacow.SetSubjectsOfInterestRequest, global::Seacow.SetSubjectsOfInterestResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "SetSubjectsOfInterest",
        __Marshaller_seacow_SetSubjectsOfInterestRequest,
        __Marshaller_seacow_SetSubjectsOfInterestResponse);

    static readonly grpc::Method<global::Seacow.GetSubjectsOfInterestRequest, global::Seacow.GetSubjectsOfInterestResponse> __Method_GetSubjectsOfInterest = new grpc::Method<global::Seacow.GetSubjectsOfInterestRequest, global::Seacow.GetSubjectsOfInterestResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetSubjectsOfInterest",
        __Marshaller_seacow_GetSubjectsOfInterestRequest,
        __Marshaller_seacow_GetSubjectsOfInterestResponse);

    static readonly grpc::Method<global::Seacow.ClearFilterRequest, global::Seacow.ClearFilterResponse> __Method_ClearFilter = new grpc::Method<global::Seacow.ClearFilterRequest, global::Seacow.ClearFilterResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "ClearFilter",
        __Marshaller_seacow_ClearFilterRequest,
        __Marshaller_seacow_ClearFilterResponse);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Seacow.SeacowReflection.Descriptor.Services[3]; }
    }

    /// <summary>Base class for server-side implementations of ContextFilter</summary>
    public abstract partial class ContextFilterBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Seacow.SetSubjectsOfInterestResponse> SetSubjectsOfInterest(global::Seacow.SetSubjectsOfInterestRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.GetSubjectsOfInterestResponse> GetSubjectsOfInterest(global::Seacow.GetSubjectsOfInterestRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.ClearFilterResponse> ClearFilter(global::Seacow.ClearFilterRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for ContextFilter</summary>
    public partial class ContextFilterClient : grpc::ClientBase<ContextFilterClient>
    {
      /// <summary>Creates a new client for ContextFilter</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public ContextFilterClient(grpc::Channel channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for ContextFilter that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public ContextFilterClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected ContextFilterClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected ContextFilterClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Seacow.SetSubjectsOfInterestResponse SetSubjectsOfInterest(global::Seacow.SetSubjectsOfInterestRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SetSubjectsOfInterest(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.SetSubjectsOfInterestResponse SetSubjectsOfInterest(global::Seacow.SetSubjectsOfInterestRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_SetSubjectsOfInterest, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.SetSubjectsOfInterestResponse> SetSubjectsOfInterestAsync(global::Seacow.SetSubjectsOfInterestRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SetSubjectsOfInterestAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.SetSubjectsOfInterestResponse> SetSubjectsOfInterestAsync(global::Seacow.SetSubjectsOfInterestRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_SetSubjectsOfInterest, null, options, request);
      }
      public virtual global::Seacow.GetSubjectsOfInterestResponse GetSubjectsOfInterest(global::Seacow.GetSubjectsOfInterestRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetSubjectsOfInterest(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.GetSubjectsOfInterestResponse GetSubjectsOfInterest(global::Seacow.GetSubjectsOfInterestRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetSubjectsOfInterest, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.GetSubjectsOfInterestResponse> GetSubjectsOfInterestAsync(global::Seacow.GetSubjectsOfInterestRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetSubjectsOfInterestAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.GetSubjectsOfInterestResponse> GetSubjectsOfInterestAsync(global::Seacow.GetSubjectsOfInterestRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetSubjectsOfInterest, null, options, request);
      }
      public virtual global::Seacow.ClearFilterResponse ClearFilter(global::Seacow.ClearFilterRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ClearFilter(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.ClearFilterResponse ClearFilter(global::Seacow.ClearFilterRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_ClearFilter, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ClearFilterResponse> ClearFilterAsync(global::Seacow.ClearFilterRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ClearFilterAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ClearFilterResponse> ClearFilterAsync(global::Seacow.ClearFilterRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_ClearFilter, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override ContextFilterClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new ContextFilterClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(ContextFilterBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_SetSubjectsOfInterest, serviceImpl.SetSubjectsOfInterest)
          .AddMethod(__Method_GetSubjectsOfInterest, serviceImpl.GetSubjectsOfInterest)
          .AddMethod(__Method_ClearFilter, serviceImpl.ClearFilter).Build();
    }

  }
  /// <summary>
  /// ContextAction Service
  /// </summary>
  public static partial class ContextAction
  {
    static readonly string __ServiceName = "seacow.ContextAction";

    static readonly grpc::Marshaller<global::Seacow.PerformRequest> __Marshaller_seacow_PerformRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.PerformRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.PerformResponse> __Marshaller_seacow_PerformResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.PerformResponse.Parser.ParseFrom);

    static readonly grpc::Method<global::Seacow.PerformRequest, global::Seacow.PerformResponse> __Method_Perform = new grpc::Method<global::Seacow.PerformRequest, global::Seacow.PerformResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "Perform",
        __Marshaller_seacow_PerformRequest,
        __Marshaller_seacow_PerformResponse);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Seacow.SeacowReflection.Descriptor.Services[4]; }
    }

    /// <summary>Base class for server-side implementations of ContextAction</summary>
    public abstract partial class ContextActionBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Seacow.PerformResponse> Perform(global::Seacow.PerformRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for ContextAction</summary>
    public partial class ContextActionClient : grpc::ClientBase<ContextActionClient>
    {
      /// <summary>Creates a new client for ContextAction</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public ContextActionClient(grpc::Channel channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for ContextAction that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public ContextActionClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected ContextActionClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected ContextActionClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Seacow.PerformResponse Perform(global::Seacow.PerformRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return Perform(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.PerformResponse Perform(global::Seacow.PerformRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_Perform, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.PerformResponse> PerformAsync(global::Seacow.PerformRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return PerformAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.PerformResponse> PerformAsync(global::Seacow.PerformRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_Perform, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override ContextActionClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new ContextActionClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(ContextActionBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_Perform, serviceImpl.Perform).Build();
    }

  }
  /// <summary>
  /// Registry Service
  /// </summary>
  public static partial class Registry
  {
    static readonly string __ServiceName = "seacow.Registry";

    static readonly grpc::Marshaller<global::Seacow.ComponentByIDRequest> __Marshaller_seacow_ComponentByIDRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ComponentByIDRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.ComponentByIDResponse> __Marshaller_seacow_ComponentByIDResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.ComponentByIDResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.LocateByTagRequest> __Marshaller_seacow_LocateByTagRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.LocateByTagRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.LocateByTagResponse> __Marshaller_seacow_LocateByTagResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.LocateByTagResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.OfTypeRequest> __Marshaller_seacow_OfTypeRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.OfTypeRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.OfTypeResponse> __Marshaller_seacow_OfTypeResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.OfTypeResponse.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.LocalActionsRequest> __Marshaller_seacow_LocalActionsRequest = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.LocalActionsRequest.Parser.ParseFrom);
    static readonly grpc::Marshaller<global::Seacow.LocalActionsResponse> __Marshaller_seacow_LocalActionsResponse = grpc::Marshallers.Create((arg) => global::Google.Protobuf.MessageExtensions.ToByteArray(arg), global::Seacow.LocalActionsResponse.Parser.ParseFrom);

    static readonly grpc::Method<global::Seacow.ComponentByIDRequest, global::Seacow.ComponentByIDResponse> __Method_ComponentByID = new grpc::Method<global::Seacow.ComponentByIDRequest, global::Seacow.ComponentByIDResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "ComponentByID",
        __Marshaller_seacow_ComponentByIDRequest,
        __Marshaller_seacow_ComponentByIDResponse);

    static readonly grpc::Method<global::Seacow.LocateByTagRequest, global::Seacow.LocateByTagResponse> __Method_LocateByTag = new grpc::Method<global::Seacow.LocateByTagRequest, global::Seacow.LocateByTagResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "LocateByTag",
        __Marshaller_seacow_LocateByTagRequest,
        __Marshaller_seacow_LocateByTagResponse);

    static readonly grpc::Method<global::Seacow.OfTypeRequest, global::Seacow.OfTypeResponse> __Method_OfType = new grpc::Method<global::Seacow.OfTypeRequest, global::Seacow.OfTypeResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "OfType",
        __Marshaller_seacow_OfTypeRequest,
        __Marshaller_seacow_OfTypeResponse);

    static readonly grpc::Method<global::Seacow.LocalActionsRequest, global::Seacow.LocalActionsResponse> __Method_LocalActions = new grpc::Method<global::Seacow.LocalActionsRequest, global::Seacow.LocalActionsResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "LocalActions",
        __Marshaller_seacow_LocalActionsRequest,
        __Marshaller_seacow_LocalActionsResponse);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Seacow.SeacowReflection.Descriptor.Services[5]; }
    }

    /// <summary>Base class for server-side implementations of Registry</summary>
    public abstract partial class RegistryBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Seacow.ComponentByIDResponse> ComponentByID(global::Seacow.ComponentByIDRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.LocateByTagResponse> LocateByTag(global::Seacow.LocateByTagRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Seacow.OfTypeResponse> OfType(global::Seacow.OfTypeRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      /// <summary>
      /// Note: this is a Manatee only operation
      /// </summary>
      /// <param name="request">The request received from the client.</param>
      /// <param name="context">The context of the server-side call handler being invoked.</param>
      /// <returns>The response to send back to the client (wrapped by a task).</returns>
      public virtual global::System.Threading.Tasks.Task<global::Seacow.LocalActionsResponse> LocalActions(global::Seacow.LocalActionsRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for Registry</summary>
    public partial class RegistryClient : grpc::ClientBase<RegistryClient>
    {
      /// <summary>Creates a new client for Registry</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public RegistryClient(grpc::Channel channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for Registry that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public RegistryClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected RegistryClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected RegistryClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Seacow.ComponentByIDResponse ComponentByID(global::Seacow.ComponentByIDRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ComponentByID(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.ComponentByIDResponse ComponentByID(global::Seacow.ComponentByIDRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_ComponentByID, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ComponentByIDResponse> ComponentByIDAsync(global::Seacow.ComponentByIDRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return ComponentByIDAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.ComponentByIDResponse> ComponentByIDAsync(global::Seacow.ComponentByIDRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_ComponentByID, null, options, request);
      }
      public virtual global::Seacow.LocateByTagResponse LocateByTag(global::Seacow.LocateByTagRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return LocateByTag(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.LocateByTagResponse LocateByTag(global::Seacow.LocateByTagRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_LocateByTag, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.LocateByTagResponse> LocateByTagAsync(global::Seacow.LocateByTagRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return LocateByTagAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.LocateByTagResponse> LocateByTagAsync(global::Seacow.LocateByTagRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_LocateByTag, null, options, request);
      }
      public virtual global::Seacow.OfTypeResponse OfType(global::Seacow.OfTypeRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return OfType(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Seacow.OfTypeResponse OfType(global::Seacow.OfTypeRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_OfType, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.OfTypeResponse> OfTypeAsync(global::Seacow.OfTypeRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return OfTypeAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Seacow.OfTypeResponse> OfTypeAsync(global::Seacow.OfTypeRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_OfType, null, options, request);
      }
      /// <summary>
      /// Note: this is a Manatee only operation
      /// </summary>
      /// <param name="request">The request to send to the server.</param>
      /// <param name="headers">The initial metadata to send with the call. This parameter is optional.</param>
      /// <param name="deadline">An optional deadline for the call. The call will be cancelled if deadline is hit.</param>
      /// <param name="cancellationToken">An optional token for canceling the call.</param>
      /// <returns>The response received from the server.</returns>
      public virtual global::Seacow.LocalActionsResponse LocalActions(global::Seacow.LocalActionsRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return LocalActions(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      /// <summary>
      /// Note: this is a Manatee only operation
      /// </summary>
      /// <param name="request">The request to send to the server.</param>
      /// <param name="options">The options for the call.</param>
      /// <returns>The response received from the server.</returns>
      public virtual global::Seacow.LocalActionsResponse LocalActions(global::Seacow.LocalActionsRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_LocalActions, null, options, request);
      }
      /// <summary>
      /// Note: this is a Manatee only operation
      /// </summary>
      /// <param name="request">The request to send to the server.</param>
      /// <param name="headers">The initial metadata to send with the call. This parameter is optional.</param>
      /// <param name="deadline">An optional deadline for the call. The call will be cancelled if deadline is hit.</param>
      /// <param name="cancellationToken">An optional token for canceling the call.</param>
      /// <returns>The call object.</returns>
      public virtual grpc::AsyncUnaryCall<global::Seacow.LocalActionsResponse> LocalActionsAsync(global::Seacow.LocalActionsRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return LocalActionsAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      /// <summary>
      /// Note: this is a Manatee only operation
      /// </summary>
      /// <param name="request">The request to send to the server.</param>
      /// <param name="options">The options for the call.</param>
      /// <returns>The call object.</returns>
      public virtual grpc::AsyncUnaryCall<global::Seacow.LocalActionsResponse> LocalActionsAsync(global::Seacow.LocalActionsRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_LocalActions, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override RegistryClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new RegistryClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(RegistryBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_ComponentByID, serviceImpl.ComponentByID)
          .AddMethod(__Method_LocateByTag, serviceImpl.LocateByTag)
          .AddMethod(__Method_OfType, serviceImpl.OfType)
          .AddMethod(__Method_LocalActions, serviceImpl.LocalActions).Build();
    }

  }
}
#endregion
